#  fsh - fast remote execution
#  Copyright (C) 1999 by Per Cederqvist.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

import string

QUOTA = 128 * 1024

def parse_line(line, want_session):
    if want_session:
        nothing = [None, None, None]
    else:
        nothing = [None, None]
    ix = 0
    # Find the command.
    while 1:
	if ix >= len(line):
	    return nothing, line
	if line[ix] in " \n":
	    break
	ix = ix + 1
    parsed_cmd = line[:ix]

    # Find the session number, if wanted.
    if want_session:
        ix = ix + 1
        iy = ix
        while 1:
            if ix >= len(line):
                return nothing, line
            if line[ix] in " \n":
                break
            ix = ix + 1
        parsed_session = string.atoi(line[iy:ix])

    # Find the string length, if any.
    if line[ix] == " ":
	ix = ix + 1
	iy = ix
	while 1:
	    if ix >= len(line):
		return nothing, line
	    if line[ix] == "H":
		break
	    if line[ix] not in "0123456789":
		return nothing, ""
	    ix = ix + 1
	parsed_len = string.atoi(line[iy:ix])
	ix = ix + 1
	iy = ix
	ix = ix + parsed_len
	if ix >= len(line):
	    return nothing, line
	data = line[iy:ix]
    else:
	data = None
    if line[ix] != "\n":
	return nothing, line
	return 1
    ix = ix + 1

    if want_session:
        return [parsed_cmd, parsed_session, data], line[ix:]
    else:
        return [parsed_cmd, data], line[ix:]

def hollerith(n):
    s = str(n)
    return "%dH%s" % (len(s), s)
